## ros-foxy-rmw-fastrtps-shared-cpp 1.3.2

=== CMakeLists.txt ===
# Copyright 2016-2018 Proyectos y Sistemas de Mantenimiento SL (eProsima).
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

cmake_minimum_required(VERSION 3.5)

project(rmw_fastrtps_shared_cpp)

# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()

if(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wthread-safety)
endif()

if(SECURITY)
  find_package(OpenSSL REQUIRED)
endif()

find_package(ament_cmake_ros REQUIRED)

find_package(rcpputils REQUIRED)
find_package(rcutils REQUIRED)
find_package(rmw_dds_common REQUIRED)

find_package(fastrtps_cmake_module REQUIRED)
find_package(fastcdr REQUIRED CONFIG)
find_package(fastrtps REQUIRED CONFIG)
find_package(FastRTPS REQUIRED MODULE)

find_package(rmw REQUIRED)

add_library(rmw_fastrtps_shared_cpp
  src/custom_publisher_info.cpp
  src/custom_subscriber_info.cpp
  src/create_rmw_gid.cpp
  src/demangle.cpp
  src/init_rmw_context_impl.cpp
  src/listener_thread.cpp
  src/namespace_prefix.cpp
  src/participant.cpp
  src/publisher.cpp
  src/qos.cpp
  src/rmw_client.cpp
  src/rmw_compare_gids_equal.cpp
  src/rmw_count.cpp
  src/rmw_event.cpp
  src/rmw_get_gid_for_publisher.cpp
  src/rmw_get_topic_endpoint_info.cpp
  src/rmw_guard_condition.cpp
  src/rmw_init.cpp
  src/rmw_logging.cpp
  src/rmw_node.cpp
  src/rmw_node_info_and_types.cpp
  src/rmw_node_names.cpp
  src/rmw_publish.cpp
  src/rmw_publisher.cpp
  src/rmw_request.cpp
  src/rmw_response.cpp
  src/rmw_security_logging.cpp
  src/rmw_service.cpp
  src/rmw_service_names_and_types.cpp
  src/rmw_service_server_is_available.cpp
  src/rmw_subscription.cpp
  src/rmw_take.cpp
  src/rmw_topic_names_and_types.cpp
  src/rmw_trigger_guard_condition.cpp
  src/rmw_wait.cpp
  src/rmw_wait_set.cpp
  src/subscription.cpp
  src/TypeSupport_impl.cpp
)
target_include_directories(rmw_fastrtps_shared_cpp
  PUBLIC
  "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>"
  "$<INSTALL_INTERFACE:include>")
target_link_libraries(rmw_fastrtps_shared_cpp
  fastcdr fastrtps
)

# specific order: dependents before dependencies
ament_target_dependencies(rmw_fastrtps_shared_cpp
  "rcpputils"
  "rcutils"
  "rmw"
  "rmw_dds_common"
)

# Causes the visibility macros to use dllexport rather than dllimport,
# which is appropriate when building the dll but not consuming it.
target_compile_definitions(${PROJECT_NAME}
PRIVATE "RMW_FASTRTPS_SHARED_CPP_BUILDING_LIBRARY")

# specific order: dependents before dependencies
ament_export_include_directories(include)
ament_export_libraries(rmw_fastrtps_shared_cpp)
ament_export_targets(rmw_fastrtps_shared_cpp)

ament_export_dependencies(rcpputils)
ament_export_dependencies(rcutils)
ament_export_dependencies(rmw)

if(BUILD_TESTING)
  find_package(ament_lint_auto REQUIRED)
  ament_lint_auto_find_test_dependencies()
  add_subdirectory(test)
endif()

ament_package(
  CONFIG_EXTRAS_POST "rmw_fastrtps_shared_cpp-extras.cmake"
)

install(
  DIRECTORY include/
  DESTINATION include
)

install(
  TARGETS rmw_fastrtps_shared_cpp EXPORT rmw_fastrtps_shared_cpp
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin
)

=== test/CMakeLists.txt ===
find_package(ament_cmake_gtest REQUIRED)
find_package(osrf_testing_tools_cpp REQUIRED)

ament_add_gtest(test_dds_attributes_to_rmw_qos test_dds_attributes_to_rmw_qos.cpp)
if(TARGET test_dds_attributes_to_rmw_qos)
    ament_target_dependencies(test_dds_attributes_to_rmw_qos)
    target_link_libraries(test_dds_attributes_to_rmw_qos ${PROJECT_NAME})
endif()

ament_add_gtest(test_rmw_qos_to_dds_attributes test_rmw_qos_to_dds_attributes.cpp)
if(TARGET test_rmw_qos_to_dds_attributes)
  target_link_libraries(test_rmw_qos_to_dds_attributes ${PROJECT_NAME})
endif()

ament_add_gmock(test_security_logging test_security_logging.cpp)
if(TARGET test_security_logging)
    ament_target_dependencies(test_security_logging)
    target_link_libraries(test_security_logging ${PROJECT_NAME})
endif()

ament_add_gtest(test_rmw_init_options test_rmw_init_options.cpp)
if(TARGET test_rmw_init_options)
  ament_target_dependencies(test_rmw_init_options osrf_testing_tools_cpp rcutils rmw)
  target_link_libraries(test_rmw_init_options ${PROJECT_NAME})
endif()

ament_add_gtest(test_guid_utils test_guid_utils.cpp)
if(TARGET test_guid_utils)
  target_link_libraries(test_guid_utils ${PROJECT_NAME})
endif()

ament_add_gtest(test_names test_names.cpp)
if(TARGET test_names)
  ament_target_dependencies(test_names rmw)
  target_link_libraries(test_names ${PROJECT_NAME})
endif()

ament_add_gtest(test_logging test_logging.cpp)
if(TARGET test_logging)
  ament_target_dependencies(test_logging
    osrf_testing_tools_cpp rcutils rmw)
  target_link_libraries(test_logging rmw_fastrtps_shared_cpp)
endif()

=== debian/changelog ===
ros-foxy-rmw-fastrtps-shared-cpp (1.3.2-1focal) focal; urgency=high

  * Take all available samples on service/client on_data_available. (backport #616 <https://github.com/ros2/rmw_fastrtps/issues/616>) (#623 <https://github.com/ros2/rmw_fastrtps/issues/623>)
  * Contributors: Miguel Company, Tomoya Fujita

 -- Michel Hidalgo <michel@ekumenlabs.com>  Sat, 27 May 2023 00:00:00 -0000

ros-foxy-rmw-fastrtps-shared-cpp (1.3.1-1focal) focal; urgency=high

  * Handle exception on deserializing ROS message (#603 <https://github.com/ros2/rmw_fastrtps/issues/603>)
  * Contributors: Erki Suurjaak, Miguel Company

 -- Michel Hidalgo <michel@ekumenlabs.com>  Mon, 25 Jul 2022 00:00:00 -0000

ros-foxy-rmw-fastrtps-shared-cpp (1.3.0-1focal) focal; urgency=high



 -- Michel Hidalgo <michel@ekumenlabs.com>  Thu, 03 Feb 2022 00:00:00 -0000

ros-foxy-rmw-fastrtps-shared-cpp (1.2.6-1focal) focal; urgency=high

  * Remove unnecessary includes (#524 <https://github.com/ros2/rmw_fastrtps/issues/524>)
  * Contributors: Miguel Company

 -- Michel Hidalgo <michel@ekumenlabs.com>  Tue, 31 Aug 2021 00:00:00 -0000

ros-foxy-rmw-fastrtps-shared-cpp (1.2.5-1focal) focal; urgency=high

  * Update quality declaration links (re: ros2/docs.ros2.org#52 <https://github.com/ros2/docs.ros2.org/issues/52>) (#521 <https://github.com/eProsima/rmw_fastrtps/issues/521>)
  * Use interface whitelist for localhost only (#476 <https://github.com/eProsima/rmw_fastrtps/issues/476>)
  * Avoid unused identifier variable warnings (#422 <https://github.com/eProsima/rmw_fastrtps/issues/422>) (#494 <https://github.com/eProsima/rmw_fastrtps/issues/494>)
  * Contributors: Jacob Perron, Michel Hidalgo, Miguel Company, Simon Honigmann, Tomoya Fujita

 -- Michel Hidalgo <michel@ekumenlabs.com>  Wed, 14 Apr 2021 00:00:00 -0000

ros-foxy-rmw-fastrtps-shared-cpp (1.2.4-1focal) focal; urgency=high

  * Make sure to lock the mutex protecting client_endpoints_ (#492 <https://github.com/ros2/rmw_fastrtps/issues/492>) (#493 <https://github.com/ros2/rmw_fastrtps/issues/493>)
  * Discriminate when the Client has gone from when the Client has not completely matched (#479 <https://github.com/ros2/rmw_fastrtps/issues/479>)
  * Contributors: Chris Lalancette, Jacob Perron

 -- Michel Hidalgo <michel@ekumenlabs.com>  Wed, 09 Dec 2020 00:00:00 -0000

ros-foxy-rmw-fastrtps-shared-cpp (1.2.3-1focal) focal; urgency=high

  * Remove unused headers MessageTypeSupport.hpp and ServiceTypeSupport.hpp (#481 <https://github.com/ros2/rmw_fastrtps/issues/481>) (#482 <https://github.com/ros2/rmw_fastrtps/issues/482>)
  * Update maintainer list for Foxy (#474 <https://github.com/ros2/rmw_fastrtps/issues/474>)
  * Updated QD
  * Provide external dependencies QD links
  * Update Quality Declarations to QL3 (#404 <https://github.com/ros2/rmw_fastrtps/issues/404>)
  * Contributors: Alejandro Hernández Cordero, JLBuenoLopez-eProsima, Jacob Perron, Michael Jeronimo, Michel Hidalgo

 -- Michel Hidalgo <michel@ekumenlabs.com>  Tue, 10 Nov 2020 00:00:00 -0000

ros-foxy-rmw-fastrtps-shared-cpp (1.2.2-1focal) focal; urgency=high

  * Set context actual domain id (#410 <https://github.com/ros2/rmw_fastrtps/issues/410>)
  * Improve __rmw_create_wait_set() implementation. (#427 <https://github.com/ros2/rmw_fastrtps/issues/427>)
    Handle errors consistently.
  * Add tests for RMW QoS to DDS attribute conversion. (#449 <https://github.com/ros2/rmw_fastrtps/issues/449>)
  * checked client implementation and return RMW_RET_INCORRECT_RMW_IMPLEMENTATION (#451 <https://github.com/ros2/rmw_fastrtps/issues/451>)
  * Update service/client request/response API error returns (#450 <https://github.com/ros2/rmw_fastrtps/issues/450>)
  * Updated rmw_* return codes (#443 <https://github.com/ros2/rmw_fastrtps/issues/443>)
  * Make service/client construction/destruction implementation compliant (#445 <https://github.com/ros2/rmw_fastrtps/issues/445>)
  * Added rmw_logging tests (#442 <https://github.com/ros2/rmw_fastrtps/issues/442>)
  * Update gid API return codes. (#440 <https://github.com/ros2/rmw_fastrtps/issues/440>)
  * Update graph API return codes. (#436 <https://github.com/ros2/rmw_fastrtps/issues/436>)
  * Updated error returns on rmw_take_serialized and with_message_info  (#435 <https://github.com/ros2/rmw_fastrtps/issues/435>)
  * Updated error returns on rmw_take (#432 <https://github.com/ros2/rmw_fastrtps/issues/432>)
  * Update rmw_publish error returns (#430 <https://github.com/ros2/rmw_fastrtps/issues/430>)
  * Update rmw_publish_serialized_message() error returns (#431 <https://github.com/ros2/rmw_fastrtps/issues/431>)
  * Ensure compliant publisher QoS queries. (#425 <https://github.com/ros2/rmw_fastrtps/issues/425>)
    Follow-up after 8fc9ca3d98a64118590a205b2162559e17309a27.
  * Ensure compliant matched pub/sub count API. (#424 <https://github.com/ros2/rmw_fastrtps/issues/424>)
  * Ensure compliant subscription API. (#419 <https://github.com/ros2/rmw_fastrtps/issues/419>)
  * Ensure compliant publisher API. (#414 <https://github.com/ros2/rmw_fastrtps/issues/414>)
  * Ensure compliant init options API implementations. (#399 <https://github.com/ros2/rmw_fastrtps/issues/399>)
  * Finalize context iff shutdown. (#396 <https://github.com/ros2/rmw_fastrtps/issues/396>)
  * Ensure compliant node construction/destruction API. (#408 <https://github.com/ros2/rmw_fastrtps/issues/408>)
  * Contributors: Alejandro Hernández Cordero, Ivan Santiago Paunovic, Jose Tomas Lorente, Michel Hidalgo

 -- Dirk Thomas <dthomas@osrfoundation.org>  Thu, 15 Oct 2020 00:00:00 -0000

ros-foxy-rmw-fastrtps-shared-cpp (1.2.1-1focal) focal; urgency=high

  * Fix memory leak that wait_set might be not destoryed in some case (#423 <https://github.com/ros2/rmw_fastrtps/issues/423>) (#426 <https://github.com/ros2/rmw_fastrtps/issues/426>)


=== debian/control ===
Source: ros-foxy-rmw-fastrtps-shared-cpp
Section: misc
Priority: optional
Maintainer: Michel Hidalgo <michel@ekumenlabs.com>
Build-Depends: debhelper (>= 9.0.0), ros-foxy-ament-cmake-ros, ros-foxy-ament-lint-auto <!nocheck>, ros-foxy-ament-lint-common <!nocheck>, ros-foxy-fastcdr, ros-foxy-fastrtps, ros-foxy-fastrtps-cmake-module, ros-foxy-osrf-testing-tools-cpp <!nocheck>, ros-foxy-rcpputils, ros-foxy-rcutils, ros-foxy-rmw, ros-foxy-rmw-dds-common, ros-foxy-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-foxy-rmw-fastrtps-shared-cpp
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-foxy-ament-cmake, ros-foxy-fastcdr, ros-foxy-fastrtps, ros-foxy-fastrtps-cmake-module, ros-foxy-rcpputils, ros-foxy-rcutils, ros-foxy-rmw, ros-foxy-rmw-dds-common, ros-foxy-ros-workspace
Description: Code shared on static and dynamic type support of rmw_fastrtps_cpp.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/foxy/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/foxy" \
		-DAMENT_PREFIX_PATH="/opt/ros/foxy" \
		-DCMAKE_PREFIX_PATH="/opt/ros/foxy" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-foxy-rmw-fastrtps-shared-cpp//opt/ros/foxy/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_install
